
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《循序渐进学Spark》一第1章 / iVAN</title>

    <meta name="description" content="《循序渐进学Spark》一第1章 第1章 Spark架构与集群环境 本章首先介绍Spark大数据处理框架的基本概念,然后介绍Spark生态系统的主要组成部分,包括Spark SQL.Spark Streaming.MLlib和GraphX,接着简要描述了Spark的架构,便于读者认识和把握,最后描述了Spark集群环境搭建及Spark开发环境的构建方法. 1.1 Spark概述与架构 随着互联网规模的爆发式增长,不断增加的数据量要求应用程序能够延伸到更大的集群中去计算.与单台机器计算不同,集群计算引发了几个关键问题,如集群计算资">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《循序渐进学Spark》一第1章</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>第1章</p>
<p>Spark架构与集群环境</p>
<p>本章首先介绍Spark大数据处理框架的基本概念，然后介绍Spark生态系统的主要组成部分，包括Spark SQL、Spark Streaming、MLlib和GraphX，接着简要描述了Spark的架构，便于读者认识和把握，最后描述了Spark集群环境搭建及Spark开发环境的构建方法。</p>
<p>1.1　Spark概述与架构</p>
<p>随着互联网规模的爆发式增长，不断增加的数据量要求应用程序能够延伸到更大的集群中去计算。与单台机器计算不同，集群计算引发了几个关键问题，如集群计算资源的共享、单点宕机、节点执行缓慢及程序的并行化。针对这几个集群环境的问题，许多大数据处理框架应运而生。比如Google的MapReduce，它提出了简单、通用并具有自动容错功能的批处理计算模型。但是MapReduce对于某些类型的计算并不适合，比如交互式和流式计算。基于这种类型需求的不一致性，大量不同于MapReduce的专门数据处理模型诞生了，如GraphLab、Impala、Storm等。大量数据模型的产生，引发的后果是对于大数据处理而言，针对不同类型的计算，通常需要一系列不同的处理框架才能完成。这些不同的处理框架由于天生的差异又带来了一系列问题：重复计算、使用范围的局限性、资源分配、统一管理，等等。</p>
<p>1.1.1　Spark概述</p>
<p>为了解决上述MapReduce及各种处理框架所带来的问题，加州大学伯克利分校推出了Spark统一大数据处理框架。Spark是一种与Hadoop MapReduce类似的开源集群大数据计算分析框架。Spark基于内存计算，整合了内存计算的单元，所以相对于hadoop的集群处理方法，Spark在性能方面更具优势。Spark启用了弹性内存分布式数据集，除了能够提供交互式查询外，还可以优化迭代工作负载。</p>
<p>从另一角度来看，Spark可以看作MapReduce的一种扩展。MapReduce之所以不擅长迭代式、交互式和流式的计算工作，主要因为它缺乏在计算的各个阶段进行有效的资源共享，针对这一点， Spark创造性地引入了RDD（弹性分布式数据集）来解决这个问题。RDD的重要特性之一就是资源共享。</p>
<p>Spark基于内存计算，提高了大数据处理的实时性，同时兼具高容错性和可伸缩性，更重要的是，Spark可以部署在大量廉价的硬件之上，形成集群。</p>
<p>提到Spark的优势就不得不提到大家熟知的Hadoop。事实上，Hadoop主要解决了两件事情：</p>
<p>1）数据的可靠存储。</p>
<p>2）数据的分析处理。</p>
<p>相应地，Hadoop也主要包括两个核心部分：</p>
<p>1）分布式文件系统（Hadoop Distributed File System，HDFS）：在集群上提供高可靠的文件存储，通过将文件块保存多个副本的办法解决服务器或硬盘故障的问题。</p>
<p>2）计算框架MapReduce：通过简单的Mapper和Reducer的抽象提供一个编程模型，可以在一个由几十台，甚至上百台机器组成的不可靠集群上并发地、分布式地处理大量的数据集，而把并发、分布式（如机器间通信）和故障恢复等计算细节隐藏起来。</p>
<p>Spark是MapReduce的一种更优的替代方案，可以兼容HDFS等分布式存储层，也可以兼容现有的Hadoop生态系统，同时弥补MapReduce的不足。</p>
<p>与Hadoop MapReduce相比，Spark的优势如下：</p>
<p>中间结果：基于MapReduce的计算引擎通常将中间结果输出到磁盘上，以达到存储和容错的目的。由于任务管道承接的缘故，一切查询操作都会产生很多串联的Stage，这些Stage输出的中间结果存储于HDFS。而Spark将执行操作抽象为通用的有向无环图（DAG），可以将多个Stage的任务串联或者并行执行，而无须将Stage中间结果输出到HDFS中。</p>
<p>执行策略：MapReduce在数据Shuffle之前，需要花费大量时间来排序，而Spark不需要对所有情景都进行排序。由于采用了DAG的执行计划，每一次输出的中间结果都可以缓存在内存中。</p>
<p>任务调度的开销：MapReduce系统是为了处理长达数小时的批量作业而设计的，在某些极端情况下，提交任务的延迟非常高。而Spark采用了事件驱动的类库AKKA来启动任务，通过线程池复用线程来避免线程启动及切换产生的开销。</p>
<p>更好的容错性：RDD之间维护了血缘关系（lineage），一旦某个RDD失败了，就能通过父RDD自动重建，保证了容错性。</p>
<p>高速：基于内存的Spark计算速度大约是基于磁盘的Hadoop<br />
MapReduce的100倍。</p>
<p>易用：相同的应用程序代码量一般比Hadoop MapReduce少50%～80%。</p>
<p>提供了丰富的API：与此同时，Spark支持多语言编程，如Scala、Python及Java，便于开发者在自己熟悉的环境下工作。Spark自带了80多个算子，同时允许在Spark Shell环境下进行交互式计算，开发者可以像书写单机程序一样开发分布式程序，轻松利用Spark搭建大数据内存计算平台，并利用内存计算特性，实时处理海量数据。</p>
<p>1.1.2　Spark生态</p>
<p>Spark大数据计算平台包含许多子模块，构成了整个Spark的生态系统，其中Spark为核心。</p>
<p>伯克利将整个Spark的生态系统称为伯克利数据分析栈（BDAS），其结构如图1-1所示。</p>
<p>以下简要介绍BDAS的各个组成部分。</p>
<p>1. Spark Core</p>
<p>Spark Core是整个BDAS的核心组件，是一种大数据分布式处理框架，不仅实现了MapReduce的算子map函数和reduce函数及计算模型，还提供如filter、join、groupByKey等更丰富的算子。Spark将分布式数据抽象为弹性分布式数据集（RDD），实现了应用任务调度、RPC、序列化和压缩，并为运行在其上的上层组件提供API。其底层采用Scala函数式语言书写而成，并且深度借鉴Scala函数式的编程思想，提供与Scala类似的编程接口。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzk3ZGYwZmYxNmM0MDM2MjE0MjRjZDVkNWJhYjU1YWRkZmZmMjliZTEucG5n.jpg"></p>
<p>2. Mesos</p>
<p>Mesos是Apache下的开源分布式资源管理框架，被称为分布式系统的内核，提供了类似YARN的功能，实现了高效的资源任务调度。</p>
<p>3. Spark<br />
Streaming</p>
<p>Spark Streaming是一种构建在Spark上的实时计算框架，它扩展了Spark处理大规模流式数据的能力。其吞吐量能够超越现有主流流处理框架Storm，并提供丰富的API用于流数据计算。</p>
<p>4. MLlib</p>
<p>MLlib 是Spark对常用的机器学习算法的实现库，同时包括相关的测试和数据生成器。MLlib 目前支持4种常见的机器学习问题：二元分类、回归、聚类以及协同过滤，还包括一个底层的梯度下降优化基础算法。</p>
<p>5. GraphX</p>
<p>GraphX是 Spark中用于图和图并行计算的API，可以认为是GraphLab和Pregel在Spark (Scala)上的重写及优化，与其他分布式图计算框架相比，GraphX最大的贡献是，在Spark上提供一栈式数据解决方案，可以方便、高效地完成图计算的一整套流水作业。</p>
<p>6. Spark SQL</p>
<p>Shark是构建在Spark和Hive基础之上的数据仓库。它提供了能够查询Hive中所存储数据的一套SQL接口，兼容现有的Hive QL语法。熟悉Hive QL或者SQL的用户可以基于Shark进行快速的Ad-Hoc、Reporting等类型的SQL查询。由于其底层计算采用了Spark，性能比Mapreduce的Hive普遍快2倍以上，当数据全部存储在内存时，要快10倍以上。2014年7月1日，Spark社区推出了Spark SQL，重新实现了SQL解析等原来Hive完成的工作，Spark SQL在功能上全覆盖了原有的Shark，且具备更优秀的性能。</p>
<p>7. Alluxio</p>
<p>Alluxio（原名Tachyon）是一个分布式内存文件系统，可以理解为内存中的HDFS。为了提供更高的性能，将数据存储剥离Java<br />
Heap。用户可以基于Alluxio实现RDD或者文件的跨应用共享，并提供高容错机制，保证数据的可靠性。</p>
<p>8. BlinkDB</p>
<p>BlinkDB是一个用于在海量数据上进行交互式SQL的近似查询引擎。它允许用户在查询准确性和查询响应时间之间做出权衡，执行相似查询。</p>
<p>1.1.3　Spark架构</p>
<p>传统的单机系统，虽然可以多核共享内存、磁盘等资源，但是当计算与存储能力无法满足大规模数据处理的需要时，面对自身CPU与存储无法扩展的先天限制，单机系统就力不从心了。</p>
<p>1. 分布式系统的架构</p>
<p>所谓的分布式系统，即为在网络互连的多个计算单元执行任务的软硬件系统，一般包括分布式操作系统、分布式数据库系统、分布式应用程序等。本书介绍的Spark分布式计算框架，可以看作分布式软件系统的组成部分，基于Spark，开发者可以编写分布式计算程序。</p>
<p>直观来看，大规模分布式系统由许多计算单元构成，每个计算单元之间松耦合。同时，每个计算单元都包含自己的CPU、内存、总线及硬盘等私有计算资源。这种分布式结构的最大特点在于不共享资源，与此同时，计算节点可以无限制扩展，计算能力和存储能力也因而得到巨大增长。但是由于分布式架构在资源共享方面的先天缺陷，开发者在书写和优化程序时应引起注意。分布式系统架构如图1-2所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzkxM2IwOTZmNTgxZmY3ZTZmMzg3ZWQyN2E5MjRhOGZlNjhmYjYxZGIucG5n.jpg"></p>
<p>为了减少网络I/O开销，分布式计算的一个核心原则是数据应该尽量做到本地计算。在计算过程中，每个计算单元之间需要传输信息，因此在信息传输较少时，分布式系统可以利用资源无限扩展的优势达到高效率，这也是分布式系统的优势。目前分布式系统在数据挖掘和决策支持等方面有着广泛的应用。</p>
<p>Spark正是基于这种分布式并行架构而产生，也可以利用分布式架构的优势，根据需要，对计算能力和存储能力进行扩展，以应对处理海量数据带来的挑战。同时，Spark的快速及容错等特性，让数据处理分析显得游刃有余。</p>
<p>2. Spark架构</p>
<p>Spark架构采用了分布式计算中的Master-Slave模型。集群中运行Master进程的节点称为Master，同样，集群中含有Worker进程的节点为Slave。Master负责控制整个集群的运行；Worker节点相当于分布式系统中的计算节点，它接收Master节点指令并返回计算进程到Master；Executor负责任务的执行；Client是用户提交应用的客户端；Driver负责协调提交后的分布式应用。具体架构如图1-3所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzkxN2Y3YjgzZThiMTYwOTY2NzY5YWY3MmI1OTdkMGViNmM5ODI5NjAucG5n.jpg"></p>
<p>在Spark应用的执行过程中，Driver和Worker是相互对应的。Driver是应用逻辑执行的起点，负责Task任务的分发和调度；Worker负责管理计算节点并创建Executor来并行处理Task任务。Task执行过程中所需的文件和包由Driver序列化后传输给对应的Worker节点，Executor对相应分区的任务进行处理。</p>
<p>下面介绍Spark架构中的组件。</p>
<p>1）Client： 提交应用的客户端。</p>
<p>2）Driver： 执行Application中的main函数并创建SparkContext。</p>
<p>3） ClusterManager：<br />
在YARN模式中为资源管理器。在Standalone模式中为Master（主节点），控制整个集群。</p>
<p>4） Worker： 从节点，负责控制计算节点。启动Executor或Driver，在YARN模式中为NodeManager。</p>
<p>5） Executor： 在计算节点上执行任务的组件。</p>
<p>6） SparkContext：<br />
应用的上下文，控制应用的生命周期。</p>
<p>7） RDD： 弹性分布式数据集，Spark的基本计算单元，一组RDD可形成有向无环图。</p>
<p>8） DAG Scheduler：<br />
根据应用构建基于Stage的DAG，并将Stage提交给Task Scheduler。</p>
<p>9） Task Scheduler：<br />
将Task分发给Executor执行。</p>
<p>10） SparkEnv： 线程级别的上下文，存储运行时重要组件的应用，具体如下:</p>
<p>①SparkConf： 存储配置信息。</p>
<p>②BroadcastManager： 负责广播变量的控制及元信息的存储。</p>
<p>③BlockManager： 负责Block的管理、创建和查找。</p>
<p>④MetricsSystem： 监控运行时的性能指标。</p>
<p>⑤MapOutputTracker： 负责shuffle元信息的存储。</p>
<p>Spark架构揭示了Spark的具体流程如下：</p>
<p>1） 用户在Client提交了应用。</p>
<p>2） Master找到Worker，并启动Driver。</p>
<p>3） Driver向资源管理器（YARN模式）或者Master（Standalone模式）申请资源，并将应用转化为RDD Graph。</p>
<p>4） DAG Scheduler将RDD Graph转化为Stage的有向无环图提交给Task<br />
Scheduler。</p>
<p>5） Task Scheduler提交任务给Executor执行。</p>
<p>3. Spark运行逻辑</p>
<p>下面举例说明Spark的运行逻辑，如图1-4所示，在Action算子被触发之后，所有累积的算子会形成一个有向无环图DAG。Spark会根据RDD之间不同的依赖关系形成Stage，每个Stage都包含一系列函数执行流水线。图1-4中A、B、C、D、E、F为不同的RDD，RDD内的方框为RDD的分区。</p>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2FlNWRjMjc1ZGIxMjc2MThlNDA1MzFkY2QwYTJlMzI5MWZiYzY3NGEucG5n.jpg"></p>
<p>图1-4　Spark执行RDD Graph</p>
<p>1）数据从HDFS输入Spark。</p>
<p>2）RDD A、RDD C 经过flatMap与Map操作后，分别转换为RDD B 和 RDD D。</p>
<p>3）RDD D经过reduceByKey操作转换为RDD E。</p>
<p>4）RDD B 与 RDD E 进行join操作转换为RDD F。</p>
<p>5）RDD F 通过函数saveAsSequenceFile输出保存到HDFS中。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-04 00:54:25</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f/" title="分布式">分布式</a>, <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e9%9b%86%e7%be%a4/" title="集群">集群</a>, <a href="https://www.iamivan.net/tag/%e5%a4%a7%e6%95%b0%e6%8d%ae/" title="大数据">大数据</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/hadoop/" title="hadoop">hadoop</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f%e7%b3%bb%e7%bb%9f/" title="分布式系统">分布式系统</a>, <a href="https://www.iamivan.net/tag/spark/" title="spark">spark</a>, <a href="https://www.iamivan.net/tag/%e6%b5%b7%e9%87%8f%e6%95%b0%e6%8d%ae/" title="海量数据">海量数据</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f%e8%ae%a1%e7%ae%97/" title="分布式计算">分布式计算</a>, <a href="https://www.iamivan.net/tag/mapreduce/" title="Mapreduce">Mapreduce</a>, <a href="https://www.iamivan.net/tag/driver/" title="driver">driver</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《循序渐进学Spark》一第1章的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgVlRZb.html" rel="bookmark">《代码之殇》（原书第2版）&mdash;&mdash;第3章 根除低下的效率 2006年7月1日</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2006年7月1日:&quot;停止写规范书,跟功能小组呆在一起&quot; 我不是项目经理(Program Manager,PM),我也从来没有担任过项目经理,我将来也不可能成为一名项目经理.这并不是因为我个人对项目经理的抵触,其实,我的朋友之中不乏出色的项目经理.很显然,我没有权利去教导项目经理应该怎么去做他们的工作. 尽管如此,项目经理应该停止写规范书.就这么简单!他们在浪费我的时间,浪费组织的时间,浪费整个公司的时间.你几乎可以听到残留着的.细微的.嘎吱嘎吱的声音,因为规范书像白蚁一样在一口一口咬			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGEnXkM.html" rel="bookmark">《代码之殇》（原书第2版）&mdash;&mdash;第3章根除低下的效率  2007年2月1日</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2007年2月1日:&quot;糟糕的规范书:该指责谁?&quot; 规范书基本上都是可怕的.不仅仅指项目管理规范书,而且也包括开发规范书和测试规范书.我说的&quot;可怕&quot;,主要是指难以撰写,难以使用,而且难以维护.你要知道,这很可怕!规范书往往还是不完善的,组织得很差,并且没有得到充分的复审.规范书永远都是这个样子,也看不到有任何变好的迹象. 为此,我想要指责项目经理,部分原因是因为我喜欢这么做,但更主要的还是因为他们是糟糕规范书的始作俑者.然而,事实不允许我指责项目经理.人人都在写糟糕的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnRxO2p.html" rel="bookmark">《代码之殇》（原书第2版）&mdash;&mdash;第2章 过程改进，没有灵丹妙药 2006年3月1日</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2006年3月1日:&quot;敏捷子弹&quot; 我很难做出判断.也许你可以帮我.我不能断定以下两种观点,哪种更糟心:一种观点认为使用&quot;敏捷&quot;方法,并且恨不得微软在全公司范围内采用它,用它解决我们面临的所有麻烦:另一种观点认为敏捷是被一些无知的学者鼓吹出来的,它实际上是一种改头换面的愚昧方法,它让开发者不用承担任何责任.这是个两难的决定,两种观点都会使我有种作呕的感觉. 作者注:这是我最喜欢的栏目之一,因为其间爱恨交错不能自已.尽管它并不完美,但我在这个主题上的评论还是相当公允的.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx091yM.html" rel="bookmark">ROS机器人程序设计（原书第2版）第1章 ROS Hydro系统入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 ROS Hydro系统入门 欢迎开始阅读本书第1章.本章将介绍如何安装ROS系统,它是一种新的标准化机器人系统软件框架.本书是基于ROS Fuerte的&lt;ROS机器人程序设计&gt;一书的升级版.通过ROS,你可以使用大量的示例代码和开源程序轻松地完成机器人编程和控制.同时,你还能够理解如何使用各种传感器与执行器,并为你的机器人增加新的功能,如自动导航和视觉感知等.得益于开源理念,以及持续开发最先进算法并不断提供新功能的开源社区,ROS不断进步完善. 通过本书,你将学习到如下内容: 在特定版			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvrog1M.html" rel="bookmark">《代码之殇》（原书第2版）&mdash;&mdash;第1章 项目管理失当&comma;2008年9月1日</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2008年9月1日:&quot;我得估算一下&quot; 尽管&quot;你的任务估算是怎么产生的?&quot;这样的疑问总是列在诸如&quot;不要对你的项目经理或同事抱怨&quot;的话题之首.但当我与刚出道的工程师们讨论问题时,首先的话题不是估算,而是职业发展和一些大众话题.这就是为什么问题总是在高谈阔论中变得无法控制.估算就是在预测未来,有太多的问题是未知而不可预见的,因而想为一个精神错乱的暴君提供一个精确的估算简直不可能.是不是?肯定是这样的,对吧? 错了.估算来自于软件工程师在规范的基础上对最			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV0JYnM.html" rel="bookmark">代码之殇》（原书第2版）&mdash;&mdash;第1章 项目管理失当  2010年5月1日</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2010年5月1日:&quot;敏捷的团队合作&quot; 我用Scrum已经7年了,而后面6年我一直写关于它的文章.Scrum的概念太吸引人了--规则多变.自我管理的团队在短而固定的周期内周而复始地进行一系列小环节(或功能)工作,并不断提升水平.很多微软团队的成功都来自于此.让人犯昏的是高层的项目经理与团队层的Scrum工程师仍存在严重隔阂. 很多高层及中层的项目经理认为Scrum是混乱的.随意的.危险的并毫无意义的,会使大家对计划失去信心:而很多Scrum迷认为项目计划是种浪费,会引起混乱,毫无价值,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boKvZgb.html" rel="bookmark">ROS机器人程序设计（原书第2版）第3章 可视化和调试工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第3章 可视化和调试工具 ROS附带了大量功能强大的工具,帮助用户和开发人员可视化和调试代码,以便检测并解决软硬件问题.其中包括消息日志系统(类似log4cxx).诊断消息.可视化以及检测工具.这些工具展示了哪些节点正在运行和它们是如何连接的.   本章我们还会展示如何用GDB调试器调试ROS节点,介绍用于日志记录的API,以及如何设置日志记录级别.接着,我们将解释如何用ROS工具集检测哪些进程正在运行以及它们之间通信的内容.例如,在下图所示的系统可视化图中可以看到正在运行的节点以及用连线表示的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQwBkp.html" rel="bookmark">《算法导论（原书第3版）》一本章注记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本章注记 关于算法的一般主题存在许多优秀的教科书,包括由以下作者编写的那些:Aho.Hopcroft和Ullman［5,6］,Baase和Van Gelder［28］,Brassard和Bratley［54］,Dasgupta.Papadimitriou和Vazirani［82］,Goodrich和Tamassia［148］,Hofri［175］,Horowitz.Sahni和Rajasekaran［181］,Johnsonbaugh和Schaefer［193］,Kingston［205］,Kl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M089xAM.html" rel="bookmark">ROS机器人程序设计（原书第2版）第2章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 ROS系统架构及概念 一旦你完成了ROS系统的安装,你肯定会想&quot;好了,我已经安装完成,那么下一步要做什么呢?&quot;在本章我们将学习ROS系统架构及它的组成.然后,我们会开始创建节点和功能包,并使用ROS系统自带的TurtleSim示例. ROS系统的架构主要被设计和划分成了三部分,每一部分都代表一个层级的概念: 文件系统级(The Filesystem level) 计算图级(The Computation Graph level ) 开源社区级(The Community lev			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwRE7p.html" rel="bookmark">《计算机网络：自顶向下方法（原书第6版）》一导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前 言 欢迎阅读&lt;计算机网络:自顶向下方法&gt;的第6版.自从本书的第1版于12年前出版以来,我们这本书已经被几百所大学和学院采用,被译为14种语言,并被世界上几十万的学生和从业人员使用.我们倾听了许多读者的意见,赞扬之声不绝于耳. 第6版的新颖之处 我们认为本书成功的一个重要原因是,持续地为计算机网络教学提供了一种新颖和与时俱进的方法.在第6版中我们做了改变,但也保持了我们认为(并且得到了使用本书的教师和学生的认可)本书最为重要的方面:它的自顶向下的方法,它关注因特网和计算机网络的现代处理方法,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zO9ZRM.html" rel="bookmark" class="title">微视频在中国的机会</a>
					<div>
						YouTube对于Google的意义在于,搜索对应的是中小广告主为主体的检索式广告,品牌广告则需要富媒体的表现形式. Google以16.5亿美元的天价收购YouTube,业内众说纷纭.有分析师叫好, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMN3ryp.html" rel="bookmark" class="title">java初学者要搞清</a>
					<div>
						初学 1.实例方法,类方法,构造器方法 我们通常所说的方法系指实例方法,就像c语言中的函数一样,其具体方法我就不用说了,在这里我主要是用它来区分类方法和构造器方法.类方法与实例方法最大的区别是:在形式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeg8wM.html" rel="bookmark" class="title">SQL数据操作基础&lpar;初级&rpar;5</a>
					<div>
						数据 使用SQL事务管理器创建新表 你可以使用前面几节所讲的方法创建新表.但是,使用事务管理器创建新表会更容易.这一节介绍如何使用这个程序创建新表. 从任务栏的SQL Sever程序组中选择SQL E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnvJOp.html" rel="bookmark" class="title">细数百度快照不更新的原因及应对策略</a>
					<div>
						最近在各大站长圈里都看到很多讨论的话题都是关乎百度快照不更新,收录减少了,但这是否会对排名有所影响?一千个人眼中有一千个哈姆雷特,现在让我谈谈我的看法: 一.快照是否影响排名? 这一直是很多人争论的问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp81AZz.html" rel="bookmark" class="title">&period;Net中如何操作IIS</a>
					<div>
						iis Net中实际上已经为我们在这方面做得很好了.FCL中提供了不少的类来帮助我们完成这项工作,让我们的开发工作变非常简单和快乐.编程控制IIS实际上很简单,和ASP一样,.Net中需要使用ADSI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myr48Pp.html" rel="bookmark" class="title">牛刀初试：智能分析系统与 Netezza 性能比拼</a>
					<div>
						前言 根据市场调研分析机构 Gartner 发布的&lt; Data Warehousing Trends for the CIO, 2011-2012 &gt; 1, Appliance(一体机)技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jNkPb.html" rel="bookmark" class="title">什么是kvm</a>
					<div>
						一.什么是kvm * Kernel-based Virtual Machine的简写,是rhel5.4推出的最新虚拟化技术,目前红帽只支持在64位的rhel5.4以上运行kvm,同时硬件需要支持VT技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrPPvp.html" rel="bookmark" class="title">自动化错误报告：通往更高软件质量的大门</a>
					<div>
						无知是福,但是在处理软件bug的时候,这句话并不适用. 软件质量专家会告诉我们,那些努力找出bug并且提高 软件质量的公司可以得到客户更多的信任,得到更高的利润,降低开发和维护的费用,简化交付的流程, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNWX8M.html" rel="bookmark" class="title">阿里云地图如何使用驾车搜索</a>
					<div>
						  点击驾车栏,在输入框中分别输入起点和终点,点击&quot;搜索&quot;按钮之后您将看到两地之间的驾车路线. 如:输入&quot;呼家楼&quot;到&quot;安贞华联&quot;,点击&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WZD8b.html" rel="bookmark" class="title">重置忘记的Win 7登录密码方法</a>
					<div>
						  为了保护个人数据,多数网友都会对自己的电脑设置登陆密码.但凡事有好的一面也会有坏的一面,如果一不小心搞错了密码,就会是一件非常郁闷的事情.不过,Win7的用户不用担心这个问题,只要你有一个U盘或是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLa92Zz.html" rel="bookmark" class="title">魅族电商运维之路</a>
					<div>
						文章出自:听云博客        电商行业飞速发展,电商事故络绎不绝,但还是有不少人热衷于电商行业,投身于电商行业.        今天我们就围绕魅族电商运维这一块的内容,来做以下四大块的分享: 业务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWdVvp.html" rel="bookmark" class="title">网络开发者常备 九款实用型Web应用软件推荐</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 众所周知,一款好的软件可极大的提高工作效率,完成一些不可能完成的工作.然我们也常常为选择哪款软件而倍感头痛.如今网络上的软件多如牛毛,分类也极其繁多,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWglxp.html" rel="bookmark" class="title">CA Technologies全力打造可延展敏捷平台</a>
					<div>
						11月25日,CA Technologies 宣布推出最新版CA敏捷中心(CA Agile Central),该解决方案是专门设计的可规模化敏捷实践的SaaS平台.解决方案的新增功能协助团队更快速执行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPQe1p.html" rel="bookmark" class="title">redis&plus;keepalived 实现HA</a>
					<div>
						  网上看到相关文章,记录一下:   http://nginx.blog.51cto.com/491911/845494   http://blog.csdn.net/zuoanlove/articl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAl96M.html" rel="bookmark" class="title">CXF创建webservice客户端和服务端</a>
					<div>
						一.CXF的介绍 Apache CXF是一个开源的WebService框架,CXF大大简化了Webservice的创建,同时它继承了XFire的传统,一样可以和spring天然的进行无缝的集成.CXF ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Zw87z.html" rel="bookmark" class="title">JSP&comma;查询TABLE中的个人信息&comma;并显示出来</a>
					<div>
						问题描述 在一个JSP页面中有两个form,第一个form中一个输入框和查询按钮,第二个form中是一个存放个人信息的table.现在要通过编号(1~10),从第一个form中的查询按钮,查询第二个f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjEl7M.html" rel="bookmark" class="title">centos性能监控-centos  cpu监控，流量监控的问题</a>
					<div>
						问题描述 centos cpu监控,流量监控的问题 监控图不连续,怀疑中途是不是web服务器重启了还是什么其它情况 解决方案 http://www.linuxidc.com/Linux/2014-01 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZZZBz.html" rel="bookmark" class="title">OpenGL ES 在 Android 开发库中 - 能不能再牛点儿</a>
					<div>
						OpenGL ES 在 Android 开发库中 - 能不能再牛点儿 太阳火神的美丽人生 (http://blog.csdn.net/opengl_es) 本文遵循&quot;署名-非商业用途-保持一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Zm3dp.html" rel="bookmark" class="title">数据结构-kruscal 求最小树 问题求大神</a>
					<div>
						问题描述 kruscal 求最小树 问题求大神 对图中的图 求出她所有的最小二叉树图中有2棵最小树 要求用kruscal 算法 我想到的是 要在排序函数中产生2 组排序 1 2 3 4 4 * 5 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZXx6z.html" rel="bookmark" class="title">Android安卓源码编译链接库问题 undefined reference 贴过程图</a>
					<div>
						问题描述 Android安卓源码编译链接库问题 undefined reference 贴过程图 参考了网上的 Android.mk写法, 各种方法添加了lib 还是 报缺失的问题. 请赐教 参考了网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZxjXM.html" rel="bookmark" class="title">vs2012  Data Provider，可能没有安装。</a>
					<div>
						问题描述 vs2012 Data Provider,可能没有安装. 在用vs2012做MVC例子的时候,报出&quot;找不到请求的 .Net Framework Data Provider.可能没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKJZqp.html" rel="bookmark" class="title">中亿万资产以上的高净值人群数量约6&period;35万人</a>
					<div>
						一份报告显示,在中国亿万资产以上的高净值人群数量约6.35万人.他们多数很低调,往往只是在如下场合显露峥嵘:跑路.入狱或征婚. 媒体报道,一场&quot;亿万富豪十城求偶秀&quot; 最近在广州首演 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRN8NBM.html" rel="bookmark" class="title">关于js中单双引号以及转义符的理解</a>
					<div>
						关于js中单引号(')和双引号(&quot;)的使用以及转义的理解 这几天一直在画页面,身为开发人员的我之所以要画页面是因为当前项目中的页面上所有的东西都是从数据库中取得的,也就是动态的,类似于我们设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4e5N1b.html" rel="bookmark" class="title">C&num;微信公众号开发系列教程五（接收事件推送与消息排重）</a>
					<div>
						原文:C#微信公众号开发系列教程五(接收事件推送与消息排重) 微信公众号开发系列教程一(调试环境部署) 微信公众号开发系列教程一(调试环境部署续:vs远程调试) C#微信公众号开发系列教程二(新手接入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLGvNM.html" rel="bookmark" class="title">天鸽互动香港上市，视频社交概念火热</a>
					<div>
						我想提到天鸽互动,可能大家对这个名字有些陌生,但是,如果一提起9158视频社区和新浪秀,那么我想很多网民应该对它们很熟悉.而拥有9158视频社区和新浪秀的天鸽互动控股有限公司,在2014年的7月9日, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5yAAz.html" rel="bookmark" class="title">在制作登陆页面的时候总是不能成功登陆&comma;以下是我的代码，用vs2005和sql2000</a>
					<div>
						问题描述 protectedvoidButton1_Click2(objectsender,EventArgse){Session[&quot;UserID&quot;]=txtUserID.Text ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvolJM.html" rel="bookmark" class="title">J2ME 环境下P12证书解析问题</a>
					<div>
						问题描述 问大家一个问题:在J2me环境下,利用bouncycastle包能不能对p12证书进行解析啊?解析出对应的私钥和证书内容. 解决方案 解决方案二:不知道你的做成功了没有.我未做成功..					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWj6Wp.html" rel="bookmark" class="title">HTC独特Facebook手机更名为Chachacha</a>
					<div>
						根据http://www.aliyun.com/zixun/aggregation/1560.html&quot;&gt;Facebook创建史改编的电影--&lt;社交网络&gt;在此前勇夺了三项7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlA10qp.html" rel="bookmark" class="title">win10系统的蓝牙在哪里？win10蓝牙如何打开</a>
					<div>
						在win10系统的电脑桌面上,点击右下放的&quot;通知栏&quot; 进入&quot;操作中心&quot;,点击&quot;蓝牙&quot;按键 这样我们就成功打开了蓝牙 点击蓝牙标示,选择&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPeGZp.html" rel="bookmark" class="title">crontab 中 python（cx&lowbar;Oracle）脚本执行时需要用户环境变量，怎么办？？</a>
					<div>
						 import cx_Oracle Traceback (most recent call last): File &quot;&quot;, line 1, in ? ImportError: li ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
